%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_G711681])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G720587]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_G729451,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G729451]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_G738405,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G738405]),'TCons'('RedBlackTree.RedBlackTree',[_G738405])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_G747401,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G747401]),'TCons'('RedBlackTree.RedBlackTree',[_G747401])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G756478]),'TCons'([],[_G756478]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_G765327]),'TCons'('RedBlackTree.RedBlackTree',[_G765327]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G774317]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G774317]),'TCons'('RedBlackTree.RedBlackTree',[_G774317])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G783403]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G783403]),'TCons'('RedBlackTree.RedBlackTree',[_G783403])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G792486]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_G792486]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_G813622,_G813623,_G813624):-freeze(_G813623,'blocked_Set.empty'(_G813622,_G813623,_G813624)).
'blocked_Set.empty'(_G813780,_G813783,_G813786):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_G813780,_G813783,_G813786).

'Set.null'(_G814446,_G814447,_G814448):-freeze(_G814447,'blocked_Set.null'(_G814446,_G814447,_G814448)).
'blocked_Set.null'(_G814484,_G814487,_G814490):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_G814484,_G814487,_G814490).

'Set.elem'(_G814840,_G814841,_G814842,_G814843):-freeze(_G814842,'blocked_Set.elem'(_G814840,_G814841,_G814842,_G814843)).
'blocked_Set.elem'(_G814878,_G815005,_G815008,_G815011):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_G814878])),_G815005,_G815008,_G815011).

'Set.insert'(_G815653,_G815654,_G815655):-freeze(_G815654,'blocked_Set.insert'(_G815653,_G815654,_G815655)).
'blocked_Set.insert'(_G815691,_G815694,_G815697):-hnf(partcall(2,'RedBlackTree.update',[]),_G815691,_G815694,_G815697).

'Set.delete'(_G816086,_G816087,_G816088):-freeze(_G816087,'blocked_Set.delete'(_G816086,_G816087,_G816088)).
'blocked_Set.delete'(_G816124,_G816127,_G816130):-hnf(partcall(2,'RedBlackTree.delete',[]),_G816124,_G816127,_G816130).

'Set.toList'(_G816519,_G816520,_G816521):-freeze(_G816520,'blocked_Set.toList'(_G816519,_G816520,_G816521)).
'blocked_Set.toList'(_G816557,_G816560,_G816563):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_G816557,_G816560,_G816563).

'Set.fromList'(_G816997,_G816998,_G816999):-freeze(_G816998,'blocked_Set.fromList'(_G816997,_G816998,_G816999)).
'blocked_Set.fromList'(_G817115,_G817118,_G817121):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_G817115,_G817118,_G817121).

'Set.union'(_G817635,_G817636,_G817637,_G817638):-freeze(_G817637,'blocked_Set.union'(_G817635,_G817636,_G817637,_G817638)).
'blocked_Set.union'(_G817673,_G817840,_G817843,_G817846):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_G817673,'Set.insert']),'Set.toList'),_G817840,_G817843,_G817846).

'Set.intersect'(_G818599,_G818600,_G818601,_G818602,_G818603):-freeze(_G818602,'blocked_Set.intersect'(_G818599,_G818600,_G818601,_G818602,_G818603)).
'blocked_Set.intersect'(_G818642,_G818651,_G819011,_G819014,_G819017):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_G818651,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_G818642))),_G819011,_G819014,_G819017).

'Set.disjoint'(_G820197,_G820198,_G820199,_G820200,_G820201):-freeze(_G820200,'blocked_Set.disjoint'(_G820197,_G820198,_G820199,_G820200,_G820201)).
'blocked_Set.disjoint'(_G820240,_G820249,_G820409,_G820412,_G820415):-hnf('Prelude.apply'('Set.null','Set.intersect'(_G820240,_G820249)),_G820409,_G820412,_G820415).

:-costCenters(['']).




%%%%% Number of shared variables: 0
